//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <vector>
#include <string>
#include <algorithm>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  //      
  vector<string> sentence;

  //     ,
  //   
  sentence.reserve(5);

  //   
  sentence.push_back(ToRus("."));
  sentence.push_back(ToRus(""));
  sentence.push_back(ToRus(""));
  sentence.push_back(ToRus(""));
  sentence.push_back("?");

  //  ,  
  copy (sentence.begin(), sentence.end(),
        ostream_iterator<string>(cout," "));
  cout << endl;

  //  " "
  cout << " max_size(): " << sentence.max_size() << endl;
  cout << " size(): " << sentence.size() << endl;
  cout << " capacity(): " << sentence.capacity() << endl;

  //     
  swap (sentence[1],sentence[3]);

  //   ""   "?"
  sentence.insert (find(sentence.begin(),sentence.end(),"?"),
                        ToRus(""));
  //  "!"  
  sentence.back() = "!";

  //  ,  
  copy (sentence.begin(), sentence.end(),
        ostream_iterator<string>(cout," "));
  cout << endl;

  //   " "
  cout << " max_size(): " << sentence.max_size() << endl;
  cout << " size(): " << sentence.size() << endl;
  cout << " capacity(): " << sentence.capacity() << endl;

  cout << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
